#include<bits/stdc++.h>
using namespace std;
int n,m,d[10005];
struct str{
	int u,v,next;
}a[10005];
inline int read()
{
	int f=1,s=0;
	char ch;
	ch=getchar();
	while(ch>'9'||ch<'0')
	{
		if(ch=='-')f=-1;
		ch=getchar();
	}
	while(ch<='9'&&ch>='0')
	{
		s=(s<<3)+(s<<1)+(ch^48);
		ch=getchar();
	}
	return s*f;
}
inline void write(int x)
{
	if(x<0)
	{
		putchar('-');
		x=-x;
	}
	if(x>9)write(x/10);
	putchar(x%10+'0');
}
int main()
{
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	n=read();
	m=read();
	for(int i=1;i<=m;i++)
	{
		int u1,v1;
		u1=read();
		v1=read();
		a[i].u=u1;
		a[i].v=v1;
		a[i].next=d[u1];
		d[u1]=i;
		a[i+m].u=v1;
		a[i+m].v=u1;
		a[i+m].next=d[v1];
		d[v1]=i+m;
	}
	if(m==n-1)
	{
		
	}
	else if(m==n)
	{
		
	}
	else if(n<=16&&m<=25)
	{
		for(int i=1;i<=m;i++)
		{
			
		}
	}
	write(184);
	fclose(stdin);fclose(stdout);
	return 0;
}
